import java.util.Vector;

class TestAATBuildTree {

    public static void main(String args[]) {
	AATBuildTree bt = new AATBuildTree();
	AATPrintTree pt = new AATPrintTree();
	AATExpression exptree;
	AATStatement stmtree, functiondefs;
	Vector actuals;

	System.out.println("=================== ");
	System.out.println("Testing Expressions ");
	System.out.println("=================== ");
	System.out.println("----------------------------");
	System.out.println("Testing literal constat : 15 ");
	System.out.println("----------------------------");
	exptree =  bt.constantExpression(15);
	exptree.Accept(pt);
	System.out.println("--------------------------");
	System.out.println("Testing expression : 4 + 5 ");
	System.out.println("--------------------------");
	exptree = bt.operatorExpression(bt.constantExpression(4),bt.constantExpression(5),
					AATOperator.PLUS);
	exptree.Accept(pt);
	System.out.println("================= ");
	System.out.println("Testing Variables ");
	System.out.println("================= ");
	System.out.println("-------------------------------");
	System.out.println("Testing base variable, offset 4 ");
	System.out.println("-------------------------------");
	exptree = bt.baseVariable(4);
	exptree.Accept(pt);
	System.out.println("----------------------------------------------------");
	System.out.println("Testing Class variable x.y  (x offset 4, y offset 8)");
	System.out.println("----------------------------------------------------");
	exptree = bt.classVariable(bt.baseVariable(4),8);
	exptree.Accept(pt);
	System.out.println("------------------------------");
	System.out.println("Testing array variable -- x[5] ");
	System.out.println(" (x offset 8, element size 4  ");
	System.out.println("------------------------------");
	exptree = bt.arrayVariable(bt.baseVariable(8),bt.constantExpression(5),4);
	exptree.Accept(pt);
	System.out.println("================== ");
	System.out.println("Testing Statements ");
	System.out.println("================== ");
	System.out.println("----------------------------------------");
	System.out.println("Assingment:  x := 3 (x local, offset = 4)");
	System.out.println("----------------------------------------");
	stmtree = bt.assignmentStatement(bt.baseVariable(4), bt.constantExpression(3));
	stmtree.Accept(pt);
	System.out.println("-----------------------------------------------------------");
	System.out.println("For: for(i=0; i < 10; i++) x := 0;   x offset 4, i offset 8 ");
	System.out.println("------------------------------------------------------------");
	stmtree = bt.forStatement(bt.assignmentStatement(bt.baseVariable(8), bt.constantExpression(0)),
				  bt.operatorExpression(bt.baseVariable(8), bt.constantExpression(10), AATOperator.LESS_THAN),
				  bt.assignmentStatement(bt.baseVariable(8),
							 bt.operatorExpression(bt.baseVariable(8),
									       bt.constantExpression(1),
									       AATOperator.PLUS)),
				  bt.assignmentStatement(bt.baseVariable(4),
							 bt.constantExpression(0)));
	stmtree.Accept(pt);
	System.out.println("--------------------------------------------");
	System.out.println("While: while (3 > 2) do x := 0 -- x offset 4");
	System.out.println("--------------------------------------------");
	stmtree = bt.whileStatement(bt.operatorExpression(bt.constantExpression(3),
							  bt.constantExpression(4),
							  AATOperator.GREATER_THAN),
				    bt.assignmentStatement(bt.baseVariable(4),
							   bt.constantExpression(0)));
	stmtree.Accept(pt);
	System.out.println("------------------------------------------------");
	System.out.println("do-while: do x := 0 while (3 > 4)  -- x offset 4");
	System.out.println("------------------------------------------------");
	stmtree = bt.dowhileStatement(bt.operatorExpression(bt.constantExpression(3),
							  bt.constantExpression(4),
							  AATOperator.GREATER_THAN),
				    bt.assignmentStatement(bt.baseVariable(4),
							   bt.constantExpression(0)));
	stmtree.Accept(pt);

    
	System.out.println("-----------------------------------------------------");
	System.out.println("If: if (5 < 4)  then x := 0 else x := 1 -- x offset 4");
	System.out.println("-----------------------------------------------------");
	stmtree  = bt.ifStatement(bt.operatorExpression(bt.constantExpression(5),
							bt.constantExpression(4),
							AATOperator.LESS_THAN),
				  bt.assignmentStatement(bt.baseVariable(4),
							 bt.constantExpression(0)),
				  bt.assignmentStatement(bt.baseVariable(4),
							 bt.constantExpression(1)));
	stmtree.Accept(pt);
	System.out.println("-----------------------------------------------------------");
	System.out.println("If: if (5 < 4)  then x := 0  /* no else  */  --  x offset 4");
	System.out.println("-----------------------------------------------------------");
	stmtree  = bt.ifStatement(bt.operatorExpression(bt.constantExpression(5),
							bt.constantExpression(4),
							AATOperator.LESS_THAN),
				  bt.assignmentStatement(bt.baseVariable(4),
							 bt.constantExpression(0)),
				  null);
	stmtree.Accept(pt);
	System.out.println("---------------------------------------");
	System.out.println("Sequential Statements: ");
	System.out.println("{ x := 0; x :=1; x := 2 } -- x offset 4");
	System.out.println("---------------------------------------");
	stmtree = bt.sequentialStatement(bt.assignmentStatement(bt.baseVariable(4),
								bt.constantExpression(0)),
					 bt.sequentialStatement(bt.assignmentStatement(bt.baseVariable(4),
										       bt.constantExpression(1)),
								bt.assignmentStatement(bt.baseVariable(4),
										       bt.constantExpression(2))));
	stmtree.Accept(pt);
	
	System.out.println("====================== ");
	System.out.println("Testing Function Calls ");
	System.out.println("====================== ");
	System.out.println("-----------------");
	System.out.println("function foo(3,4) ");
	System.out.println("-----------------");
	actuals = new Vector(2);
	actuals.addElement(bt.constantExpression(3));
	actuals.addElement(bt.constantExpression(4));
	exptree = bt.callExpression(actuals, new Label("foo"));
	exptree.Accept(pt);
	System.out.println("----------------------");
	System.out.println("void function bar(3,4) ");
	System.out.println("----------------------");
	actuals = new Vector(2);
	actuals.addElement(bt.constantExpression(3));
	actuals.addElement(bt.constantExpression(4));
	stmtree = bt.callStatement(actuals, new Label("bar"));
	stmtree.Accept(pt);
	
	System.out.println("============================ ");
	System.out.println("Testing Function Definitions ");
	System.out.println("============================ ");
	System.out.println("-----------------------------------");
	System.out.println("int f() ");
	System.out.println("   Framesize = 8, ");
	System.out.println("   body:  x := 2 (x offset = 4) ");
	System.out.println("-----------------------------------");
	functiondefs = bt.functionDefinition(bt.assignmentStatement(bt.baseVariable(4),
							       bt.constantExpression(2)),
					8, new Label("f"), new Label("fend"));
	functiondefs.Accept(pt);

    }
}





